/*
** my_functions.h
**
** Made by mycroft (mycroft)
** <mycroft@minithins.net> on virgaria.minithins.net
**
** Started on  Tue Jan 14 00:16:14 2003 mycroft
** Last update Tue Jan 14 00:16:14 2003 mycroft
*/

#ifndef HEADER_MY_FUNCTION
#define HEADER_MY_FUNCTION

#include <sys/types.h>


#ifdef DEBUG
#define my_malloc(memory) \
    my_function_malloc ((memory), __FILE__, __func__, __LINE__)

#define my_free(memory) \
    my_function_free ((memory), __FILE__, __func__, __LINE__)
#else
#define my_malloc(memory) malloc(memory)
#define my_free(memory) free(memory)
#endif

/* Don't use these one. Use my_malloc and my_free */
void *my_function_malloc (size_t size, char *s, char *f, int i);
void my_function_free (void *buf, char *s, char *f, int i);
void my_memory_repport (void);
void *my_realloc (void *ptr, size_t oldsize, size_t newsize);

void *my_memcpy(void *dst, const void *src, size_t len);
void *my_memset(void *b, int c, size_t len);

int my_strlen(char *str);
int my_strcmp (const char *s1, const char *s2);
int my_strncmp (const char *s1, const char *s2, size_t len);
int my_strcasecmp (const char *s1, const char *s2);
int my_strncasecmp (const char *s1, const char *s2, size_t n);
char *my_strcpy(char *dst, const char *src);
char *my_strcat(char *s, const char *append);

char *my_malloc_strcpy (char *str);
char *malloc_copie_cat (char *str1, char *str2);

char *my_get_path_home (char *file);
char *strip_spaces (char *str);
char *str_to_first_word (char *str);
char **my_str_to_wordtab (char * str , char sep);

char *get_next_line (int fd);

int my_tolower (int c);

ssize_t my_read(int fd, void *buf, size_t count);
ssize_t my_write(int fd, const void *buf, size_t count);

#endif /* HEADER_MY_FUNCTION */
